 /********************************************************************/
 /****                                                            ****/
 /****                                                            ****/
 /****    Program          : Intui-Funktionen                     ****/
 /****                                                            ****/
 /****    Version          :    01.06                             ****/
 /****                                                            ****/
 /****    Erstversion      : 21.05.1988                           ****/
 /****                                                            ****/
 /****    Letzte nderung  : 23.03.1990                           ****/
 /****                                                            ****/
 /****    Compiliert mit   : siehe MAKE                           ****/
 /****                                                            ****/
 /****    Gelinkt mit      : Fr Tool.Library                     ****/
 /****                                                            ****/
 /********************************************************************/
 /****                                                            ****/
 /****                                                            ****/
 /****               Copyright by Rdiger Dreier                  ****/
 /****                                                            ****/
 /****                                                            ****/
 /********************************************************************/
 
 #include "ToolProto.h"
 #include <intuition/intuition.h>
 #include <intuition/intuitionbase.h>
 #include <libraries/dos.h>
 #include <graphics/gfxmacros.h>
 #include <exec/memory.h>
 #include <intuition/intuitionbase.h>
 #include <proto/intuition.h>
 #include <proto/graphics.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 
 
 #define ACTIVE_SCREEN IntuitionBase->ActiveScreen
 #define ACTIVE_WINDOW IntuitionBase->ActiveWindow
 #define CODE  ((Message!=0) ? Message->Code  : 0)
 #define CLASS ((Message!=0) ? Message->Class : 0)
 #define CircleFill(RP,x,y,r) EllFill(RP,x,y,r,r);
 
 extern struct IntuitionBase *IntuitionBase;
 extern struct GfxBase       *GfxBase;
 
 extern long ARequest(struct Window *, struct IntuiText *, struct IntuiText *, struct IntuiText *, long, long, long, long);
 
 
 LONG __asm request(register __d0 char *JaPointer,
                    register __d1 char *NeinPointer,
                    register __d2 char *BodyPointer)
  {
   return(NewRequest(ACTIVE_WINDOW,JaPointer,NeinPointer,BodyPointer));
  }
 
 
 LONG __asm NewRequest(register __a0 struct Window *AktWindow,
                       register __d0 char *JaPointer,
                       register __d1 char *NeinPointer,
                       register __d2 char *BodyPointer)
  {
   struct IntuiText Ja,Nein,ReqText;
   LONG MaxPix,la,lb;
   
   la=strlen(JaPointer)+strlen(NeinPointer);
   lb=strlen(BodyPointer);
   MaxPix=max(la*8+90,lb*8+50);
   
   Ja.FrontPen=Nein.FrontPen=ReqText.FrontPen=0;
   Ja.BackPen=Nein.BackPen=ReqText.BackPen=1;
   Ja.DrawMode=Nein.DrawMode=ReqText.DrawMode=JAM2;
   Ja.LeftEdge=Nein.LeftEdge=6;
   Ja.TopEdge=Nein.TopEdge=4;
   ReqText.LeftEdge=ReqText.TopEdge=8;
   Ja.ITextFont=Nein.ITextFont=ReqText.ITextFont=NULL;
   Ja.NextText=Nein.NextText=ReqText.NextText=NULL;
   Ja.IText=JaPointer;
   Nein.IText=NeinPointer;
   ReqText.IText=BodyPointer;
   la=AutoRequest(AktWindow,&ReqText,&Ja,&Nein,0L,0L,MaxPix,60L);
   return(la);
  }
 
